diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-phy.cc ns-3.34/src/wifi/model/vht/vht-phy.cc
--- ns-3.33/src/wifi/model/vht/vht-phy.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,536 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ */
+
+#include "vht-phy.h"
+#include "vht-ppdu.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-phy.h" //only used for static mode constructor
+#include "ns3/wifi-utils.h"
+#include "ns3/log.h"
+#include "ns3/assert.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("VhtPhy");
+
+/*******************************************************
+ *       VHT PHY (IEEE 802.11-2016, clause 21)
+ *******************************************************/
+
+/* *NS_CHECK_STYLE_OFF* */
+const PhyEntity::PpduFormats VhtPhy::m_vhtPpduFormats {
+  { WIFI_PREAMBLE_VHT_SU, { WIFI_PPDU_FIELD_PREAMBLE,      //L-STF + L-LTF
+                            WIFI_PPDU_FIELD_NON_HT_HEADER, //L-SIG
+                            WIFI_PPDU_FIELD_SIG_A,         //VHT-SIG-A
+                            WIFI_PPDU_FIELD_TRAINING,      //VHT-STF + VHT-LTFs
+                            WIFI_PPDU_FIELD_DATA } },
+  { WIFI_PREAMBLE_VHT_MU, { WIFI_PPDU_FIELD_PREAMBLE,      //L-STF + L-LTF
+                            WIFI_PPDU_FIELD_NON_HT_HEADER, //L-SIG
+                            WIFI_PPDU_FIELD_SIG_A,         //VHT-SIG-A
+                            WIFI_PPDU_FIELD_TRAINING,      //VHT-STF + VHT-LTFs
+                            WIFI_PPDU_FIELD_SIG_B,         //VHT-SIG-B
+                            WIFI_PPDU_FIELD_DATA } }
+};
+
+const VhtPhy::NesExceptionMap VhtPhy::m_exceptionsMap {
+                 /* {BW,Nss,MCS} Nes */
+  { std::make_tuple ( 80, 7, 2),  3 },   //instead of 2
+  { std::make_tuple ( 80, 7, 7),  6 },   //instead of 4
+  { std::make_tuple ( 80, 7, 8),  6 },   //instead of 5
+  { std::make_tuple ( 80, 8, 7),  6 },   //instead of 5
+  { std::make_tuple (160, 4, 7),  6 },   //instead of 5
+  { std::make_tuple (160, 5, 8),  8 },   //instead of 7
+  { std::make_tuple (160, 6, 7),  8 },   //instead of 7
+  { std::make_tuple (160, 7, 3),  4 },   //instead of 3
+  { std::make_tuple (160, 7, 4),  6 },   //instead of 5
+  { std::make_tuple (160, 7, 5),  7 },   //instead of 6
+  { std::make_tuple (160, 7, 7),  9 },   //instead of 8
+  { std::make_tuple (160, 7, 8), 12 },   //instead of 9
+  { std::make_tuple (160, 7, 9), 12 }    //instead of 10
+};
+/* *NS_CHECK_STYLE_ON* */
+
+VhtPhy::VhtPhy (bool buildModeList /* = true */)
+  : HtPhy (1, false) //don't add HT modes to list
+{
+  NS_LOG_FUNCTION (this << buildModeList);
+  m_bssMembershipSelector = VHT_PHY;
+  m_maxMcsIndexPerSs = 9;
+  m_maxSupportedMcsIndexPerSs = m_maxMcsIndexPerSs;
+  if (buildModeList)
+    {
+      BuildModeList ();
+    }
+}
+
+VhtPhy::~VhtPhy ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+VhtPhy::BuildModeList (void)
+{
+  NS_LOG_FUNCTION (this);
+  NS_ASSERT (m_modeList.empty ());
+  NS_ASSERT (m_bssMembershipSelector == VHT_PHY);
+  for (uint8_t index = 0; index <= m_maxSupportedMcsIndexPerSs; ++index)
+    {
+      NS_LOG_LOGIC ("Add VhtMcs" << +index << " to list");
+      m_modeList.emplace_back (CreateVhtMcs (index));
+    }
+}
+
+const PhyEntity::PpduFormats &
+VhtPhy::GetPpduFormats (void) const
+{
+  return m_vhtPpduFormats;
+}
+
+WifiMode
+VhtPhy::GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const
+{
+  switch (field)
+    {
+      case WIFI_PPDU_FIELD_TRAINING: //consider SIG-A mode for training (useful for InterferenceHelper)
+      case WIFI_PPDU_FIELD_SIG_A:
+        return GetSigAMode ();
+      case WIFI_PPDU_FIELD_SIG_B:
+        return GetSigBMode (txVector);
+      default:
+        return HtPhy::GetSigMode (field, txVector);
+    }
+}
+
+WifiMode
+VhtPhy::GetHtSigMode (void) const
+{
+  NS_ASSERT (m_bssMembershipSelector != HT_PHY);
+  NS_FATAL_ERROR ("No HT-SIG");
+  return WifiMode ();
+}
+
+WifiMode
+VhtPhy::GetSigAMode (void) const
+{
+  return GetLSigMode (); //same number of data tones as OFDM (i.e. 48)
+}
+
+WifiMode
+VhtPhy::GetSigBMode (const WifiTxVector& txVector) const
+{
+  NS_ABORT_MSG_IF (txVector.GetPreambleType () != WIFI_PREAMBLE_VHT_MU, "VHT-SIG-B only available for VHT MU");
+  return GetVhtMcs0 ();
+}
+
+Time
+VhtPhy::GetDuration (WifiPpduField field, const WifiTxVector& txVector) const
+{
+  switch (field)
+    {
+      case WIFI_PPDU_FIELD_SIG_A:
+        return GetSigADuration (txVector.GetPreambleType ());
+      case WIFI_PPDU_FIELD_SIG_B:
+        return GetSigBDuration (txVector);
+      default:
+        return HtPhy::GetDuration (field, txVector);
+    }
+}
+
+Time
+VhtPhy::GetLSigDuration (WifiPreamble /* preamble */) const
+{
+  return MicroSeconds (4); //L-SIG
+}
+
+Time
+VhtPhy::GetHtSigDuration (void) const
+{
+  return MicroSeconds (0); //no HT-SIG
+}
+
+Time
+VhtPhy::GetTrainingDuration (const WifiTxVector& txVector,
+                             uint8_t nDataLtf, uint8_t nExtensionLtf /* = 0 */) const
+{
+  NS_ABORT_MSG_IF (nDataLtf > 8, "Unsupported number of LTFs " << +nDataLtf << " for VHT");
+  NS_ABORT_MSG_IF (nExtensionLtf > 0, "No extension LTFs expected for VHT");
+  return MicroSeconds (4 + 4 * nDataLtf); //VHT-STF + VHT-LTFs
+}
+
+Time
+VhtPhy::GetSigADuration (WifiPreamble /* preamble */) const
+{
+  return MicroSeconds (8); //VHT-SIG-A (first and second symbol)
+}
+
+Time
+VhtPhy::GetSigBDuration (const WifiTxVector& txVector) const
+{
+  return (txVector.GetPreambleType () == WIFI_PREAMBLE_VHT_MU) ? MicroSeconds (4) : MicroSeconds (0); //HE-SIG-B only for MU
+}
+
+uint8_t
+VhtPhy::GetNumberBccEncoders (const WifiTxVector& txVector) const
+{
+  WifiMode payloadMode = txVector.GetMode ();
+  /**
+   * General rule: add an encoder when crossing maxRatePerCoder frontier
+   *
+   * The value of 540 Mbps and 600 Mbps for normal GI and short GI (resp.)
+   * were obtained by observing the rates for which Nes was incremented in tables
+   * 21-30 to 21-61 of IEEE 802.11-2016.
+   * These values are the last values before changing encoders.
+   */
+  double maxRatePerCoder = (txVector.GetGuardInterval () == 800) ? 540e6 : 600e6;
+  uint8_t nes = ceil (payloadMode.GetDataRate (txVector) / maxRatePerCoder);
+
+  //Handle exceptions to the rule
+  auto iter = m_exceptionsMap.find (std::make_tuple (txVector.GetChannelWidth (),
+                                                     txVector.GetNss (),
+                                                     payloadMode.GetMcsValue ()));
+  if (iter != m_exceptionsMap.end ())
+    {
+      nes = iter->second;
+    }
+  return nes;
+}
+
+Ptr<WifiPpdu>
+VhtPhy::BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration)
+{
+  NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration);
+  return Create<VhtPpdu> (psdus.begin ()->second, txVector, ppduDuration, m_wifiPhy->GetPhyBand (),
+                          ObtainNextUid (txVector));
+}
+
+PhyEntity::PhyFieldRxStatus
+VhtPhy::DoEndReceiveField (WifiPpduField field, Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << field << *event);
+  switch (field)
+    {
+      case WIFI_PPDU_FIELD_SIG_A:
+        return EndReceiveSigA (event);
+      case WIFI_PPDU_FIELD_SIG_B:
+        return EndReceiveSigB (event);
+      default:
+        return HtPhy::DoEndReceiveField (field, event);
+    }
+}
+
+PhyEntity::PhyFieldRxStatus
+VhtPhy::EndReceiveSigA (Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << *event);
+  NS_ASSERT (event->GetTxVector ().GetPreambleType () >= WIFI_PREAMBLE_VHT_SU);
+  SnrPer snrPer = GetPhyHeaderSnrPer (WIFI_PPDU_FIELD_SIG_A, event);
+  NS_LOG_DEBUG ("SIG-A: SNR(dB)=" << RatioToDb (snrPer.snr) << ", PER=" << snrPer.per);
+  PhyFieldRxStatus status (GetRandomValue () > snrPer.per);
+  if (status.isSuccess)
+    {
+      NS_LOG_DEBUG ("Received SIG-A");
+      if (!IsAllConfigSupported (WIFI_PPDU_FIELD_SIG_A, event->GetPpdu ()))
+        {
+          status = PhyFieldRxStatus (false, UNSUPPORTED_SETTINGS, DROP);
+        }
+      status = ProcessSigA (event, status);
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Drop packet because SIG-A reception failed");
+      status.reason = SIG_A_FAILURE;
+      status.actionIfFailure = DROP;
+    }
+  return status;
+}
+
+PhyEntity::PhyFieldRxStatus
+VhtPhy::ProcessSigA (Ptr<Event> event, PhyFieldRxStatus status)
+{
+  NS_LOG_FUNCTION (this << *event << status);
+  //TODO see if something should be done here once MU-MIMO is supported
+  return status; //nothing special for VHT
+}
+
+PhyEntity::PhyFieldRxStatus
+VhtPhy::EndReceiveSigB (Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << *event);
+  NS_ASSERT (event->GetPpdu ()->GetType () == WIFI_PPDU_TYPE_DL_MU);
+  SnrPer snrPer = GetPhyHeaderSnrPer (WIFI_PPDU_FIELD_SIG_B, event);
+  NS_LOG_DEBUG ("SIG-B: SNR(dB)=" << RatioToDb (snrPer.snr) << ", PER=" << snrPer.per);
+  PhyFieldRxStatus status (GetRandomValue () > snrPer.per);
+  if (status.isSuccess)
+    {
+      NS_LOG_DEBUG ("Received SIG-B");
+      if (!IsAllConfigSupported (WIFI_PPDU_FIELD_SIG_A, event->GetPpdu ()))
+        {
+          status = PhyFieldRxStatus (false, UNSUPPORTED_SETTINGS, DROP);
+        }
+      status = ProcessSigB (event, status);
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Drop reception because SIG-B reception failed");
+      status.reason = SIG_B_FAILURE;
+      status.actionIfFailure = DROP;
+    }
+  return status;
+}
+
+PhyEntity::PhyFieldRxStatus
+VhtPhy::ProcessSigB (Ptr<Event> event, PhyFieldRxStatus status)
+{
+  NS_LOG_FUNCTION (this << *event << status);
+  //TODO see if something should be done here once MU-MIMO is supported
+  return status; //nothing special for VHT
+}
+
+bool
+VhtPhy::IsAllConfigSupported (WifiPpduField field, Ptr<const WifiPpdu> ppdu) const
+{
+  if (ppdu->GetType () == WIFI_PPDU_TYPE_DL_MU && field == WIFI_PPDU_FIELD_SIG_A)
+    {
+      return IsChannelWidthSupported (ppdu); //perform the full check after SIG-B
+    }
+  return HtPhy::IsAllConfigSupported (field, ppdu);
+}
+
+void
+VhtPhy::InitializeModes (void)
+{
+  for (uint8_t i = 0; i < 10; ++i)
+    {
+      GetVhtMcs (i);
+    }
+}
+
+WifiMode
+VhtPhy::GetVhtMcs (uint8_t index)
+{
+#define CASE(x) \
+case x: \
+  return GetVhtMcs ## x (); \
+
+  switch (index)
+    {
+      CASE ( 0)
+      CASE ( 1)
+      CASE ( 2)
+      CASE ( 3)
+      CASE ( 4)
+      CASE ( 5)
+      CASE ( 6)
+      CASE ( 7)
+      CASE ( 8)
+      CASE ( 9)
+      default:
+        NS_ABORT_MSG ("Inexistent index (" << +index << ") requested for VHT");
+        return WifiMode ();
+    }
+#undef CASE
+}
+
+#define GET_VHT_MCS(x) \
+WifiMode \
+VhtPhy::GetVhtMcs ## x (void) \
+{ \
+  static WifiMode mcs = CreateVhtMcs (x); \
+  return mcs; \
+}; \
+
+GET_VHT_MCS (0)
+GET_VHT_MCS (1)
+GET_VHT_MCS (2)
+GET_VHT_MCS (3)
+GET_VHT_MCS (4)
+GET_VHT_MCS (5)
+GET_VHT_MCS (6)
+GET_VHT_MCS (7)
+GET_VHT_MCS (8)
+GET_VHT_MCS (9)
+#undef GET_VHT_MCS
+
+WifiMode
+VhtPhy::CreateVhtMcs (uint8_t index)
+{
+  NS_ASSERT_MSG (index <= 9, "VhtMcs index must be <= 9!");
+  return WifiModeFactory::CreateWifiMcs ("VhtMcs" + std::to_string (index),
+                                         index,
+                                         WIFI_MOD_CLASS_VHT,
+                                         MakeBoundCallback (&GetCodeRate, index),
+                                         MakeBoundCallback (&GetConstellationSize, index),
+                                         MakeBoundCallback (&GetPhyRate, index),
+                                         MakeCallback (&GetPhyRateFromTxVector),
+                                         MakeBoundCallback (&GetDataRate, index),
+                                         MakeCallback (&GetDataRateFromTxVector),
+                                         MakeBoundCallback (&GetNonHtReferenceRate, index),
+                                         MakeBoundCallback (&IsModeAllowed, index));
+}
+
+WifiCodeRate
+VhtPhy::GetCodeRate (uint8_t mcsValue)
+{
+  switch (mcsValue)
+    {
+      case 8:
+        return WIFI_CODE_RATE_3_4;
+      case 9:
+        return WIFI_CODE_RATE_5_6;
+      default:
+        return HtPhy::GetCodeRate (mcsValue);
+    }
+}
+
+uint16_t
+VhtPhy::GetConstellationSize (uint8_t mcsValue)
+{
+  switch (mcsValue)
+    {
+      case 8:
+      case 9:
+        return 256;
+      default:
+        return HtPhy::GetConstellationSize (mcsValue);
+    }
+}
+
+uint64_t
+VhtPhy::GetPhyRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+{
+  WifiCodeRate codeRate = GetCodeRate (mcsValue);
+  uint64_t dataRate = GetDataRate (mcsValue, channelWidth, guardInterval, nss);
+  return HtPhy::CalculatePhyRate (codeRate, dataRate);
+}
+
+uint64_t
+VhtPhy::GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
+{
+  return GetPhyRate (txVector.GetMode ().GetMcsValue (),
+                     txVector.GetChannelWidth (),
+                     txVector.GetGuardInterval (),
+                     txVector.GetNss ());
+}
+
+uint64_t
+VhtPhy::GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
+{
+  return GetDataRate (txVector.GetMode ().GetMcsValue (),
+                      txVector.GetChannelWidth (),
+                      txVector.GetGuardInterval (),
+                      txVector.GetNss ());
+}
+
+uint64_t
+VhtPhy::GetDataRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+{
+  NS_ASSERT (guardInterval == 800 || guardInterval == 400);
+  NS_ASSERT (nss <= 8);
+  NS_ASSERT_MSG (IsModeAllowed (mcsValue, channelWidth, nss), "VHT MCS " << +mcsValue << " forbidden at " << channelWidth << " MHz when NSS is " << +nss);
+  return HtPhy::CalculateDataRate (3.2, guardInterval,
+                                   GetUsableSubcarriers (channelWidth),
+                                   static_cast<uint16_t> (log2 (GetConstellationSize (mcsValue))),
+                                   HtPhy::GetCodeRatio (GetCodeRate (mcsValue)), nss);
+}
+
+uint16_t
+VhtPhy::GetUsableSubcarriers (uint16_t channelWidth)
+{
+  switch (channelWidth)
+    {
+      case 80:
+        return 234;
+      case 160:
+        return 468;
+      default:
+        return HtPhy::GetUsableSubcarriers (channelWidth);
+    }
+}
+
+uint64_t
+VhtPhy::GetNonHtReferenceRate (uint8_t mcsValue)
+{
+  WifiCodeRate codeRate = GetCodeRate (mcsValue);
+  uint16_t constellationSize = GetConstellationSize (mcsValue);
+  return CalculateNonHtReferenceRate (codeRate, constellationSize);
+}
+
+uint64_t
+VhtPhy::CalculateNonHtReferenceRate (WifiCodeRate codeRate, uint16_t constellationSize)
+{
+  uint64_t dataRate;
+  switch (constellationSize)
+    {
+      case 256:
+        if (codeRate == WIFI_CODE_RATE_3_4 || codeRate == WIFI_CODE_RATE_5_6)
+          {
+            dataRate = 54000000;
+          }
+        else
+          {
+            NS_FATAL_ERROR ("Trying to get reference rate for a MCS with wrong combination of coding rate and modulation");
+          }
+        break;
+      default:
+        dataRate = HtPhy::CalculateNonHtReferenceRate (codeRate, constellationSize);
+    }
+  return dataRate;
+}
+
+bool
+VhtPhy::IsModeAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss)
+{
+  if (mcsValue == 9 && channelWidth == 20 && nss != 3)
+    {
+      return false;
+    }
+  if (mcsValue == 6 && channelWidth == 80 && nss == 3)
+    {
+      return false;
+    }
+  return true;
+}
+
+uint32_t
+VhtPhy::GetMaxPsduSize (void) const
+{
+  return 4692480;
+}
+
+} //namespace ns3
+
+namespace {
+
+/**
+ * Constructor class for VHT modes
+ */
+static class ConstructorVht
+{
+public:
+  ConstructorVht ()
+  {
+    ns3::VhtPhy::InitializeModes ();
+    ns3::WifiPhy::AddStaticPhyEntity (ns3::WIFI_MOD_CLASS_VHT, ns3::Create<ns3::VhtPhy> ());
+  }
+} g_constructor_vht; ///< the constructor for VHT modes
+
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-phy.h ns-3.34/src/wifi/model/vht/vht-phy.h
--- ns-3.33/src/wifi/model/vht/vht-phy.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,353 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ */
+
+#ifndef VHT_PHY_H
+#define VHT_PHY_H
+
+#include "ns3/ht-phy.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::VhtPhy class.
+ */
+
+namespace ns3 {
+
+/**
+ * This defines the BSS membership value for VHT PHY.
+ */
+#define VHT_PHY 126
+
+/**
+ * \brief PHY entity for VHT (11ac)
+ * \ingroup wifi
+ *
+ * VHT PHY is based on HT PHY.
+ *
+ * Refer to IEEE 802.11-2016, clause 21.
+ */
+class VhtPhy : public HtPhy
+{
+public:
+  /**
+   * Constructor for VHT PHY
+   *
+   * \param buildModeList flag used to add VHT modes to list (disabled
+   *                      by child classes to only add child classes' modes)
+   */
+  VhtPhy (bool buildModeList = true);
+  /**
+   * Destructor for VHT PHY
+   */
+  virtual ~VhtPhy ();
+
+  WifiMode GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const override;
+  const PpduFormats & GetPpduFormats (void) const override;
+  Time GetDuration (WifiPpduField field, const WifiTxVector& txVector) const override;
+  Time GetLSigDuration (WifiPreamble preamble) const override;
+  Time GetTrainingDuration (const WifiTxVector& txVector,
+                            uint8_t nDataLtf,
+                            uint8_t nExtensionLtf = 0) const override;
+  Ptr<WifiPpdu> BuildPpdu (const WifiConstPsduMap & psdus,
+                           const WifiTxVector& txVector,
+                           Time ppduDuration) override;
+
+  /**
+   * \return the WifiMode used for the SIG-A field
+   */
+  virtual WifiMode GetSigAMode (void) const;
+  /**
+   * \param txVector the transmission parameters
+   * \return the WifiMode used for the SIG-B field
+   */
+  virtual WifiMode GetSigBMode (const WifiTxVector& txVector) const;
+
+  /**
+   * \param preamble the type of preamble
+   * \return the duration of the SIG-A field
+   */
+  virtual Time GetSigADuration (WifiPreamble preamble) const;
+  /**
+   * \param txVector the transmission parameters
+   * \return the duration of the SIG-B field
+   */
+  virtual Time GetSigBDuration (const WifiTxVector& txVector) const;
+
+  /**
+   * Initialize all VHT modes.
+   */
+  static void InitializeModes (void);
+  /**
+   * Return the VHT MCS corresponding to
+   * the provided index.
+   *
+   * \param index the index of the MCS
+   * \return an VHT MCS
+   */
+  static WifiMode GetVhtMcs (uint8_t index);
+
+  /**
+   * Return MCS 0 from VHT MCS values.
+   *
+   * \return MCS 0 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs0 (void);
+  /**
+   * Return MCS 1 from VHT MCS values.
+   *
+   * \return MCS 1 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs1 (void);
+  /**
+   * Return MCS 2 from VHT MCS values.
+   *
+   * \return MCS 2 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs2 (void);
+  /**
+   * Return MCS 3 from VHT MCS values.
+   *
+   * \return MCS 3 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs3 (void);
+  /**
+   * Return MCS 4 from VHT MCS values.
+   *
+   * \return MCS 4 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs4 (void);
+  /**
+   * Return MCS 5 from VHT MCS values.
+   *
+   * \return MCS 5 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs5 (void);
+  /**
+   * Return MCS 6 from VHT MCS values.
+   *
+   * \return MCS 6 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs6 (void);
+  /**
+   * Return MCS 7 from VHT MCS values.
+   *
+   * \return MCS 7 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs7 (void);
+  /**
+   * Return MCS 8 from VHT MCS values.
+   *
+   * \return MCS 8 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs8 (void);
+  /**
+   * Return MCS 9 from VHT MCS values.
+   *
+   * \return MCS 9 from VHT MCS values
+   */
+  static WifiMode GetVhtMcs9 (void);
+
+  /**
+   * Return the coding rate corresponding to
+   * the supplied VHT MCS index. This function is
+   * reused by child classes and is used as a callback
+   * for WifiMode operation.
+   *
+   * \param mcsValue the MCS index
+   * \return the coding rate.
+   */
+  static WifiCodeRate GetCodeRate (uint8_t mcsValue);
+  /**
+   * Return the constellation size corresponding
+   * to the supplied VHT MCS index. This function is
+   * reused by child classes and is used as a callback for
+   * WifiMode operation.
+   *
+   * \param mcsValue the MCS index
+   * \return the size of modulation constellation.
+   */
+  static uint16_t GetConstellationSize (uint8_t mcsValue);
+  /**
+   * Return the PHY rate corresponding to the supplied VHT MCS
+   * index, channel width, guard interval, and number of
+   * spatial stream. This function calls HtPhy::CalculatePhyRate
+   * and is mainly used as a callback for WifiMode operation.
+   *
+   * \param mcsValue the VHT MCS index
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of stream
+   *
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Return the PHY rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate corresponding to
+   * the supplied VHT MCS index, channel width,
+   * guard interval, and number of spatial
+   * streams.
+   *
+   * \param mcsValue the MCS index
+   * \param channelWidth the channel width in MHz
+   * \param guardInterval the guard interval duration in nanoseconds
+   * \param nss the number of spatial streams
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Calculate the rate in bps of the non-HT Reference Rate corresponding
+   * to the supplied VHT MCS index. This function calls CalculateNonHtReferenceRate
+   * and is used as a callback for WifiMode operation.
+   *
+   * \param mcsValue the VHT MCS index
+   * \return the rate in bps of the non-HT Reference Rate.
+   */
+  static uint64_t GetNonHtReferenceRate (uint8_t mcsValue);
+  /**
+   * Check whether the combination of <MCS, channel width, NSS> is allowed.
+   * This function is used as a callback for WifiMode operation.
+   *
+   * \param mcsValue the considered MCS index
+   * \param channelWidth the considered channel width in MHz
+   * \param nss the considered number of streams
+   * \returns true if this <MCS, channel width, NSS> combination is allowed, false otherwise.
+   */
+  static bool IsModeAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss);
+
+protected:
+  WifiMode GetHtSigMode (void) const override;
+  Time GetHtSigDuration (void) const override;
+  uint8_t GetNumberBccEncoders (const WifiTxVector& txVector) const override;
+  PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
+  bool IsAllConfigSupported (WifiPpduField field, Ptr<const WifiPpdu> ppdu) const override;
+  uint32_t GetMaxPsduSize (void) const override;
+
+  /**
+   * End receiving the SIG-A, perform VHT-specific actions, and
+   * provide the status of the reception.
+   *
+   * Child classes can perform amendment-specific actions by specializing
+   * \see ProcessSigA.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \return status of the reception of the SIG-A
+   */
+  PhyFieldRxStatus EndReceiveSigA (Ptr<Event> event);
+  /**
+   * End receiving the SIG-B, perform VHT-specific actions, and
+   * provide the status of the reception.
+   *
+   * Child classes can perform amendment-specific actions by specializing
+   * \see ProcessSigB.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \return status of the reception of the SIG-B
+   */
+  PhyFieldRxStatus EndReceiveSigB (Ptr<Event> event);
+
+  /**
+   * Process SIG-A, perform amendment-specific actions, and
+   * provide an updated status of the reception.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \param status the status of the reception of the correctly received SIG-A after the configuration support check
+   * \return the updated status of the reception of the SIG-A
+   */
+  virtual PhyFieldRxStatus ProcessSigA (Ptr<Event> event, PhyFieldRxStatus status);
+  /**
+   * Process SIG-B, perform amendment-specific actions, and
+   * provide an updated status of the reception.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \param status the status of the reception of the correctly received SIG-B after the configuration support check
+   * \return the updated status of the reception of the SIG-B
+   */
+  virtual PhyFieldRxStatus ProcessSigB (Ptr<Event> event, PhyFieldRxStatus status);
+
+  /**
+   * Return the rate (in bps) of the non-HT Reference Rate
+   * which corresponds to the supplied code rate and
+   * constellation size.
+   *
+   * \param codeRate the convolutional coding rate
+   * \param constellationSize the size of modulation constellation
+   * \returns the rate in bps.
+   *
+   * To convert an VHT MCS to its corresponding non-HT Reference Rate
+   * use the modulation and coding rate of the HT MCS
+   * and lookup in Table 10-7 of IEEE 802.11-2016.
+   */
+  static uint64_t CalculateNonHtReferenceRate (WifiCodeRate codeRate, uint16_t constellationSize);
+  /**
+   * \param channelWidth the channel width in MHz
+   * \return he number of usable subcarriers for data
+   */
+  static uint16_t GetUsableSubcarriers (uint16_t channelWidth);
+
+private:
+  void BuildModeList (void) override;
+
+  /**
+   * Return the VHT MCS corresponding to
+   * the provided index.
+   * This method binds all the callbacks used by WifiMode.
+   *
+   * \param index the index of the MCS
+   * \return a VHT MCS
+   */
+  static WifiMode CreateVhtMcs (uint8_t index);
+
+  /**
+   * Typedef for storing exceptions in the number of BCC encoders for VHT MCSs
+   */
+  typedef std::map< std::tuple<uint16_t /* channelWidth in MHz */,
+                               uint8_t /* Nss */,
+                               uint8_t /* MCS index */>, uint8_t /* Nes */ > NesExceptionMap;
+  static const NesExceptionMap m_exceptionsMap; //!< exception map for number of BCC encoders (extracted from VHT-MCS tables)
+  static const PpduFormats m_vhtPpduFormats;    //!< VHT PPDU formats
+}; //class VhtPhy
+
+} //namespace ns3
+
+#endif /* VHT_PHY_H */
